3PAR manually created host detach KeyError: 'WWN' hp_3par_common.py

Bug #1274334 reported by Michael Denny on 2014-01-29
24
This bug affects 5 people
Affects Status Importance Assigned to Milestone
Cinder
Undecided
Walt Boring

Bug Description

how to duplicate
Manually creating host in 3PAR IMC with wwn from host
create volume
Attach volume
detach volume

2014-01-29 15:09:47.582 DEBUG cinder.openstack.common.lockutils [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455f
cad] Got semaphore "3par" for method "terminate_connection"... from (pid=6822) inner /opt/stack/cinder/cinder/openstack/common/lockutils.py:191
2014-01-29 15:09:47.583 DEBUG cinder.openstack.common.lockutils [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455f
cad] Attempting to grab file lock "3par" for method "terminate_connection"... from (pid=6822) inner /opt/stack/cinder/cinder/openstack/common/lockutils.py:202
2014-01-29 15:09:47.584 DEBUG cinder.openstack.common.lockutils [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455f
cad] Got file lock "3par" at /opt/stack/data/cinder/cinder-3par for method "terminate_connection"... from (pid=6822) inner /opt/stack/cinder/cinder/openstack/common/loc
kutils.py:232
2014-01-29 15:09:47.584 DEBUG cinder.volume.drivers.san.hp.hp_3par_common [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5
657274455fcad] Connecting to 3PAR from (pid=6822) client_login /opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_common.py:178
2014-01-29 15:09:48.021 DEBUG cinder.volume.drivers.san.hp.hp_3par_common [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5
657274455fcad] Disconnect from 3PAR from (pid=6822) client_logout /opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_common.py:189
2014-01-29 15:09:48.022 DEBUG cinder.openstack.common.lockutils [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455f
cad] Released file lock "3par" at /opt/stack/data/cinder/cinder-3par for method "terminate_connection"... from (pid=6822) inner /opt/stack/cinder/cinder/openstack/commo
n/lockutils.py:239
2014-01-29 15:09:48.022 ERROR cinder.openstack.common.rpc.amqp [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455fc
ad] Exception during message handling
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp Traceback (most recent call last):
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/openstack/common/rpc/amqp.py", line 441, in _process_data
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp **args)
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/openstack/common/rpc/dispatcher.py", line 148, in dispatch
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp return getattr(proxyobj, method)(ctxt, **kwargs)
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/utils.py", line 821, in wrapper
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp return func(self, *args, **kwargs)
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/volume/manager.py", line 660, in terminate_connection
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp self.driver.terminate_connection(volume_ref, connector, force=force)
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/openstack/common/lockutils.py", line 233, in inner
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp retval = f(*args, **kwargs)
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_fc.py", line 226, in terminate_connection
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp wwn=connector['wwpns'])
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_common.py", line 1024, in terminate_connec
tion
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp hostname = self._get_3par_hostname_from_wwn_iqn(wwn, iqn)
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp File "/opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_common.py", line 1010, in _get_3par_hostna
me_from_wwn_iqn
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp if wwn == fc['WWN']:
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp KeyError: 'WWN'
2014-01-29 15:09:48.022 TRACE cinder.openstack.common.rpc.amqp
2014-01-29 15:09:48.024 ERROR cinder.openstack.common.rpc.common [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455
fcad] Returning exception 'WWN' to caller
2014-01-29 15:09:48.025 ERROR cinder.openstack.common.rpc.common [req-f29fe230-471a-4821-8849-c4e895d8a204 77447ba13f024c8db5f0b94617e890c4 e6e6663adee94511ac5657274455
fcad] ['Traceback (most recent call last):\n', ' File "/opt/stack/cinder/cinder/openstack/common/rpc/amqp.py", line 441, in _process_data\n **args)\n', ' File "/op
t/stack/cinder/cinder/openstack/common/rpc/dispatcher.py", line 148, in dispatch\n return getattr(proxyobj, method)(ctxt, **kwargs)\n', ' File "/opt/stack/cinder/ci
nder/utils.py", line 821, in wrapper\n return func(self, *args, **kwargs)\n', ' File "/opt/stack/cinder/cinder/volume/manager.py", line 660, in terminate_connection
\n self.driver.terminate_connection(volume_ref, connector, force=force)\n', ' File "/opt/stack/cinder/cinder/openstack/common/lockutils.py", line 233, in inner\n
 retval = f(*args, **kwargs)\n', ' File "/opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_fc.py", line 226, in terminate_connection\n wwn=connector[\'wwpns\']
)\n', ' File "/opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_common.py", line 1024, in terminate_connection\n hostname = self._get_3par_hostname_from_wwn_iq
n(wwn, iqn)\n', ' File "/opt/stack/cinder/cinder/volume/drivers/san/hp/hp_3par_common.py", line 1010, in _get_3par_hostname_from_wwn_iqn\n if wwn == fc[\'WWN\']:\n'
, "KeyError: 'WWN'\n"]

Fix proposed to branch: master
Review: https://review.openstack.org/70020

Changed in cinder:
assignee: nobody → Walt Boring (walter-boring)
status: New → In Progress

Reviewed: https://review.openstack.org/70020
Committed: https://git.openstack.org/cgit/openstack/cinder/commit/?id=dc4655a5ae5a2ad576b68f3bc7d5044e395ee49e
Submitter: Jenkins
Branch: master

commit dc4655a5ae5a2ad576b68f3bc7d5044e395ee49e
Author: Walter A. Boring IV <email address hidden>
Date: Wed Jan 29 15:53:53 2014 -0800

    Fixes incorrect key in dictionary

    This is a corner case for the 3PAR driver.
    The dictionary has a key of 'wwn', not 'WWN'.

    Change-Id: Id16a54f14d195a7297ab8db8fc8e2642955338e6
    Closes-Bug: #1274334

Changed in cinder:
status: In Progress → Fix Committed
Thierry Carrez (ttx) on 2014-03-05
Changed in cinder:
milestone: none → icehouse-3
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2014-04-17
Changed in cinder:
milestone: icehouse-3 → 2014.1
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers